package org.tipple.mapDisplay;

import java.util.HashMap;
import java.util.List;

public class tippleLocation {
	private double radius = 0.0;

	private double longitude = 0.0;

	private String text = null;

	private double latitude = 0.0;

	private String title = null;

	private String nodeID = null;
	private String tts_text_ = null;

	protected String id_ = null;

	private String audioFilename = null;
	private List<String> audioPaths;
	private String chapter = null;

	public tippleLocation() {

	}

	public tippleLocation(String title, double radius, double longitude,
			double latitude, String content, String tts, String chapter) {
		this.radius = radius;
		this.longitude = longitude;
		this.title = title;
		this.latitude = latitude;
		this.text = content;
		this.tts_text_ = tts;
		this.chapter = chapter;

	}

	public tippleLocation(HashMap<String, String> hashmap) {
		latitude = Double.parseDouble(hashmap.get("Latitude"));
		longitude = Double.parseDouble(hashmap.get("Longitude"));
		radius = Double.parseDouble(hashmap.get("Radius"));
		nodeID = hashmap.containsKey("nodeID") ? hashmap.get("nodeID") : null;
		title = hashmap.containsKey("Title") ? hashmap.get("Title") : null;
		text = (hashmap.containsKey("text")) ? hashmap.get("text") : null;
		tts_text_ = (hashmap.containsKey("tts")) ? hashmap.get("tts") : null;
		chapter = (hashmap.containsKey("Chapter")) ? hashmap.get("Chapter")
				: null;
		audioFilename = (hashmap.containsKey("audio")) ? hashmap.get("audio")
				: null;
		// Consolidate whitespace
		title = title.replaceAll("^\\s+", "");
		title = title.replaceAll("\\s+$", "");
		title = title.replaceAll("\\s+", " ");
		if (text != null) {
			text = text.replaceAll("^\\s+", "");
			text = text.replaceAll("\\s+$", "");
			text = text.replaceAll("\\s+", " ");
		}
		chapter = chapter.replaceAll("^\\s+", "");
		chapter = chapter.replaceAll("\\s+$", "");
		chapter = chapter.replaceAll("\\s+", " ");
		id_ = title.replaceAll("/\\s+/", "-");

	}

	public String getChapter() {
		return chapter;
	}

	public List<String> getAudio() {
		return audioPaths;
	}

	public String getAudioFilename() {
		return audioFilename;
	}

	public String getID() {
		return id_;
	}

	public String getNodeID() {

		return nodeID;
	}

	public void setNodeID(String nodeID) {

		this.nodeID = nodeID;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public double getlongitude() {
		return longitude;
	}

	public void setlongitude(double longitude) {
		this.longitude = longitude;
	}

	public double getradius() {
		return radius;
	}

	public void setradius(double radius) {
		this.radius = radius;
	}

	public double getlatitude() {
		return latitude;
	}

	public void setlatitude(double latitude) {
		this.latitude = latitude;
	}

	public String getContent() {

		return text;
	}

	public void setContent(String content) {

		this.text = content;
	}

	public String getTTSText() {
		return (tts_text_ != null) ? tts_text_ : text;
	}

	public String toString() {

		StringBuffer sb = new StringBuffer();
		sb.append("TippleLocation Details - ");
		sb.append("Title:" + getTitle());
		sb.append(", ");
		sb.append("latitude:" + getlatitude());
		sb.append(", ");
		sb.append("longitude:" + getlongitude());
		sb.append(",");
		sb.append("Radius" + getradius());
		sb.append(".");
		sb.append("nodeID:" + getNodeID());
		sb.append(", ");

		return sb.toString();

		/*
		 * return "TippleLocation Details - " + "Title:" + getTitle() +
		 * "latitude:" + getlatitude() + "Radius" + getradius();
		 */

	}

}
