package org.tipple.mapDisplay;

import java.util.ArrayList;
import java.util.HashMap;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class xmlHandler extends DefaultHandler {
	String lockon_element;
	Boolean locked_on_;
	ArrayList<HashMap<String, String>> lockon_list;
	HashMap<String, String> hashmap;
	String active_element;
	StringBuffer inner_text;
	String active_attr;
	Boolean recordElement;
	String elementType;

	// ===========================================================
	// Getter & Setter
	// ===========================================================
	public xmlHandler(String lockon_element) {
		// initial settings to parse a file
		this.lockon_element = lockon_element;
		lockon_list = new ArrayList<HashMap<String, String>>();
		locked_on_ = false;
		recordElement = false;
		elementType = "";
		hashmap = new HashMap<String, String>();
	}

	public ArrayList<HashMap<String, String>> getHashmapList() {
		return lockon_list;
	}

	/**
	 * Gets be called on opening tags like: <tag> Can provide attribute(s), when
	 * xml was like: <tag attribute="attributeValue">
	 */

	public void startElement(String namespaceURI, String localName,
			String qName, Attributes atts) throws SAXException {

		if ((localName.equalsIgnoreCase(lockon_element))
				&& (atts.getValue("nodeType")).equalsIgnoreCase("leaf")) {

			hashmap = new HashMap<String, String>();
			locked_on_ = true; // => covert each child element inside this to a
			String attrValueNode = atts.getValue("nodeID");
			hashmap.put("nodeID", attrValueNode);

		} else if (locked_on_) {
			if (localName.equalsIgnoreCase("metadata")
					|| localName.equalsIgnoreCase("nodeContent")) {
				recordElement = true;
				inner_text = new StringBuffer();
				if (localName.equalsIgnoreCase("metadata")) {
					active_element = atts.getValue("name");

				} else if (localName.equalsIgnoreCase("nodeContent")) {
					active_element = "text";

				}
			}

		}
		// else ignore element as outside area of interest
	}

	/**
	 * Gets be called on closing tags like: </tag>
	 */
	public void endElement(String namespaceURI, String localName, String qName)
			throws SAXException {
		if (localName.equalsIgnoreCase(lockon_element)) {
			// push hashmap onto arraylist
			lockon_list.add(hashmap);
			hashmap = null;
			locked_on_ = false;
		} else if ((localName.equalsIgnoreCase("metadata"))
				|| (localName.equalsIgnoreCase("nodeContent"))) {
			active_element = null;
			inner_text = null;
			recordElement = false;

		}

	}

	/**
	 * Gets be called on the following structure: <tag>characters</tag>
	 */

	public void characters(char ch[], int start, int length) {
		if (this.recordElement) {
			String text = new String(ch, start, length);
			inner_text.append(text);
			hashmap.put(active_element, inner_text.toString());

		}
	}

}
